<?

/**
 *                                                                 
 */
function humanfilesize($filesize) {
if ($filesize === FALSE) {
return '--';
}
$units = array( 'B', 'KB', 'MB', 'GB' );
for( $unit = 0 ; $filesize > 1500 && $unit < count($units) ; $unit++) {
$filesize /= 1024;
}
return sprintf( "%.1f %s", $filesize, $units[$unit]);
}


/**
 *                                                       
 */
function filesize2bytes($str) { 
$bytes = 0; 

$bytes_array = array( 
'B' => 1, 
'K' => 1024, 
'M' => 1024 * 1024, 
'G' => 1024 * 1024 * 1024,
'T' => 1024 * 1024 * 1024 * 1024, 
'P' => 1024 * 1024 * 1024 * 1024 * 1024, 
); 

$bytes = floatval($str); 

if (preg_match('#([KMGTP])$#si', $str, $matches) && !empty($bytes_array[$matches[1]])) { 
$bytes *= $bytes_array[$matches[1]]; 
} 

$bytes = intval(round($bytes, 2)); 

return $bytes; 
}

/**
 *                  //          /      /  /                    
 */
function gtxreturn_bytes($val) {
$val = trim($val);
$last = strtolower($val{strlen($val)-1});
switch($last) {
//                                              
 case 'g':
$val *= 1024;
case 'm':
$val *= 1024;
case 'k':
$val *= 1024;
}

return $val;
}

?>