<?
node_include( "guifactory" );
GUIFactory::setMainGUI( "main" );

mysession_var_reg("USAGE_TYPE");
mysession_var_reg("USAGE_OBJS");
mysession_var_reg("USAGE_PAGEUSAGE");

load_menu(11001,$T_FOLDER,$FOLDER_ID,i18n("usageinfo_for", 0, count($USAGE_OBJS), get_dicname($USAGE_TYPE, count($USAGE_OBJS) == 1)),1,"pagelist");

//                                                       
if ($USAGE_TYPE === "10006_PAGETAGS") {
$USAGE_TYPE = $T_PAGE;
}

if ($cmd == "detail") {
//                
 if ($t_type == $T_PAGE) {
//                                                                                                                     
 if ($USAGE_PAGEUSAGE) {
$USAGE_TYPE = $t_type;
}
$REDO = 13011;
} else if ($t_type == $T_TEMPLATE) {
if ($USAGE_PAGEUSAGE) {
$USAGE_TYPE = $t_type;
}
$REDO = 13013;
} else if ($t_type == $T_FILE || $t_type == $T_IMAGE) {
$type = $t_type == $T_FILE ? "file" : "img";
$REDO = 15001;
} else if ($t_type == $T_FOLDER) {
$REDO = 13012;
}
} else {

$usage_infos = array();
if ($USAGE_TYPE == $T_PAGE && $USAGE_PAGEUSAGE) {
$usage = get_page_usageinfo(array_keys($USAGE_OBJS));

$usage_infos[] = array("ttype" => $T_PAGE, "icon" => img($ICO_PAGE), "name" => i18n("Seitenvarianten"), "total" => $usage[$T_PAGE]["total"], "noperm" => $usage[$T_PAGE]["noperm"]);
$usage_infos[] = array("ttype" => $T_PAGE . "_PAGETAGS", "icon" => img($ICO_PAGE), "name" => i18n("Seitentags in Seiten"), "total" => $usage[$T_PAGE . "_PAGETAGS"]["total"], "noperm" => $usage[$T_PAGE . "_PAGETAGS"]["noperm"]);
$usage_infos[] = array("ttype" => $T_TEMPLATE . "_PAGETAGS", "icon" => img($ICO_TPL), "name" => i18n("Seitentags in Vorlagen"), "total" => $usage[$T_TEMPLATE . "_PAGETAGS"]["total"], "noperm" => $usage[$T_TEMPLATE . "_PAGETAGS"]["noperm"]);
} else {
$usage = get_usageinfo($USAGE_TYPE, array_keys($USAGE_OBJS));

$usage_infos[] = array("ttype" => $T_PAGE, "icon" => img($ICO_PAGE), "name" => get_dicname($T_PAGE), "total" => $usage[$T_PAGE]["total"], "noperm" => $usage[$T_PAGE]["noperm"]);
$usage_infos[] = array("ttype" => $T_TEMPLATE, "icon" => img($ICO_TPL), "name" => get_dicname($T_TEMPLATE), "total" => $usage[$T_TEMPLATE]["total"], "noperm" => $usage[$T_TEMPLATE]["noperm"]);
$usage_infos[] = array("ttype" => $T_FOLDER, "icon" => img($ICO_FOLDER), "name" => get_dicname($T_FOLDER), "total" => $usage[$T_FOLDER]["total"], "noperm" => $usage[$T_FOLDER]["noperm"]);
$usage_infos[] = array("ttype" => $T_IMAGE, "icon" => img($ICO_IMG), "name" => get_dicname($T_IMAGE), "total" => $usage[$T_IMAGE]["total"], "noperm" => $usage[$T_IMAGE]["noperm"]);
$usage_infos[] = array("ttype" => $T_FILE, "icon" => img($ICO_FILE), "name" => get_dicname($T_FILE), "total" => $usage[$T_FILE]["total"], "noperm" => $usage[$T_FILE]["noperm"]);
}

$form = new HtmlForm3("usageinfo");
$form->setHeader( i18n("usageinfo_for", 0, count($USAGE_OBJS), get_dicname($USAGE_TYPE, count($USAGE_OBJS) == 1)), null );

$main = new ListComponent();
$list = new ArrayDatasource($usage_infos, array("icon" => "", "name" => i18n("name"), "total" => i18n("usageinfo_total"), "noperm" => i18n("usageinfo_noperm")));
$list->makeLink( "name", "name", "do=$DO&cmd=detail", '', "t_type", "ttype" );
$main->setComponent("usageinfo", new ItemListComponent( NULL, new ItemList3("usageinfo", $list ) ));
$form->addComponent("main", $main);
$form->addButton( 'cancel', new Button( i18n( 'Back' ), false ), new SimpleFormAction('cancelOverview'), true );
}

//                                          
if ($do_cancel) {
unset($USAGE_TYPE);
unset($USAGE_OBJS);
}

function cancelOverview( $form ) {
global $REDO, $USAGE_TYPE, $USAGE_OBJS, $T_PAGE, $T_IMAGE, $T_FILE, $do_cancel;

switch($USAGE_TYPE) {
case $T_PAGE:
$REDO = 13011;
break;
case $T_FILE:
$REDO = 15001;
$type = "file";
break;
case $T_IMAGE:
$REDO = 15001;
$type = "img";
break;
}
unset($USAGE_TYPE);
unset($USAGE_OBJS);
mysession_var_unreg("USAGE_TYPE");
mysession_var_unreg("USAGE_OBJS");
$do_cancel = true;
}

/**
 *                                                          
 *                                               
 *                              
 *                                                                                      
 */
function get_usageinfo($type, $objs) {
global $T_FILE, $T_IMAGE, $T_PAGE, $T_TEMPLATE, $T_FOLDER, $USER_ID;
$ids = implode(",", $objs);
$ret = array();

//                                                        

//                                         

if ($type == $T_FILE || $type == $T_IMAGE) {
$part_types = "6, 8, 14";
$ds_types = "$T_FILE, $T_IMAGE";
} else if ($type == $T_PAGE) {
$part_types = "4";
$ds_types = "$T_PAGE";
} else if ($type == $T_TEMPLATE) {
$part_types = "11";
$ds_types = "-1";		
} else {
return false;
}

//                           
 $sql = get_usageinfo_sql($type, $objs, $T_PAGE, true);
$rs = query($sql);//            
 $noperm = 0;
//                                         
 foreach ($rs["arr"] as $row) {
$pageperms = perm( $USER_ID, $T_FOLDER, $row['folder_id']);
if ( !$pageperms[11] ) {
$noperm++;
}
}
$ret[$T_PAGE]["total"] = $rs["num"];
$ret[$T_PAGE]["noperm"] = $noperm;

//                               
 $sql = get_usageinfo_sql($type, $objs, $T_TEMPLATE, true);
$rs = query($sql);//            
 $noperm = 0;
foreach ($rs["arr"] as $row) {
//                                                    
 $templateperm = perm($USER_ID, $T_FOLDER, $row["folder_id"], 15);

if (!$templateperm) {
//                                                                  
 //                                                                                             
 $folder_rs = query("SELECT folder_id FROM template_folder WHERE template_id = ".sqlf_tl_num($row["id"]));//            
 foreach ($folder_rs["arr"] as $folder) {
if (perm($USER_ID, $T_FOLDER, $folder["folder_id"], 15)) {
$templateperm = true;
break;
}
}
}
if ( !$templateperm ) {
$noperm++;
}
}
$ret[$T_TEMPLATE]["total"] = $rs["num"];
$ret[$T_TEMPLATE]["noperm"] = $noperm;

//                             
 $sql = get_usageinfo_sql($type, $objs, $T_FOLDER, true);
$rs = query($sql);//            
 $noperm = 0;
foreach ($rs["arr"] as $row) {
$folderperms = perm( $USER_ID, $T_FOLDER, $row['id']);
if ( !$folderperms[0] ) {
$noperm++;
}
}
$ret[$T_FOLDER]["total"] = $rs["num"];
$ret[$T_FOLDER]["noperm"] = $noperm;

//                               
 $sql = get_usageinfo_sql($type, $objs, $T_FILE, true);
$rs = query($sql);//            
 $noperm = 0;
foreach ($rs["arr"] as $row) {
$fileperms = perm( $USER_ID, $T_FOLDER, $row['folder_id']);
if ( !$fileperms[11] ) {
$noperm++;
}
}
$ret[$T_FILE]["total"] = $rs["num"];
$ret[$T_FILE]["noperm"] = $noperm;

//                                 
 $sql = get_usageinfo_sql($type, $objs, $T_IMAGE, true);
$rs = query($sql);//            
 $noperm = 0;
foreach ($rs["arr"] as $row) {
$pageperms = perm( $USER_ID, $T_FOLDER, $row['folder_id']);
if ( !$pageperms[11] ) {
$noperm++;
}
}
$ret[$T_IMAGE]["total"] = $rs["num"];
$ret[$T_IMAGE]["noperm"] = $noperm;

return $ret;
}

/**
 *                                             
 *                              
 *                                                                                      
 */
function get_page_usageinfo($objs) {
global $T_PAGE, $T_TEMPLATE, $T_FOLDER, $USER_ID;

$ret = array();

$sql = get_usageinfo_sql($T_PAGE, $objs, $T_PAGE, true);
//                  
 $rs = query($sql);//            
 $noperm = 0;

//                                         
 foreach ($rs["arr"] as $row) {
$pageperms = perm( $USER_ID, $T_FOLDER, $row['folder_id']);
if ( !$pageperms[11] ) {
$noperm++;
}
}
$ret[$T_PAGE]["total"] = $rs["num"];
$ret[$T_PAGE]["noperm"] = $noperm;

$sql = get_usageinfo_sql($T_PAGE . "_PAGETAGS", $objs, $T_PAGE, true);
//                              
 $rs = query($sql);//            
 $noperm = 0;

//                                         
 foreach ($rs["arr"] as $row) {
$pageperms = perm( $USER_ID, $T_FOLDER, $row['folder_id']);
if ( !$pageperms[11] ) {
$noperm++;
}
}
$ret[$T_PAGE . "_PAGETAGS"]["total"] = $rs["num"];
$ret[$T_PAGE . "_PAGETAGS"]["noperm"] = $noperm;

$sql = get_usageinfo_sql($T_TEMPLATE . "_PAGETAGS", $objs, $T_TEMPLATE, true);
//                                 
 $rs = query($sql);//            
 $noperm = 0;

//                                         
 foreach ($rs["arr"] as $row) {
$pageperms = perm( $USER_ID, $T_FOLDER, $row['folder_id']);
if ( !$pageperms[11] ) {
$noperm++;
}
}
$ret[$T_TEMPLATE . "_PAGETAGS"]["total"] = $rs["num"];
$ret[$T_TEMPLATE . "_PAGETAGS"]["noperm"] = $noperm;

return $ret;
}
?>
