<?
function construct_load() {

global $LANGUAGE, $CONSTRUCTS;

if (is_array($CONSTRUCTS)) return;

$sql = "SELECT construct.id, dicuser.value AS name, LOWER(dicuser.value) AS l_name FROM construct, dicuser 
WHERE construct.name_id = dicuser.output_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE)." ORDER BY l_name";
$rs = query($sql);//            
 $rs = reduce_array($rs["arr"],"id","name");
$CONSTRUCTS = $rs;

}

function get_constructlist($node_id, $onlyintext = TRUE, $extrawhere = '') {
global $LANGUAGE;
$where = get_visible_constructs("construct.id",$node_id);
$sql = "SELECT value AS name, construct.id, icon, LOWER(dicuser.value) AS l_name FROM construct LEFT JOIN dicuser ON (dicuser.output_id = construct.name_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE).") WHERE $where $extrawhere " . ($onlyintext ? ' AND construct.intext = 1 ' : '' ) . " ORDER BY l_name";
$rs = query($sql);//            
 return $rs["arr"];
}
/**
 *                                                  
 *                                                                       
 */
function get_constructlist_by_category($node_id, $extrawhere = "") {
global $LANGUAGE, $FEATURE;
if( !$FEATURE['construct_categories'] ) return get_constructlist( $node_id, FALSE, $extrawhere );
$where = get_visible_constructs("construct.id",$node_id);
$sql = "SELECT dicuser.value AS name, construct.id, icon, LOWER(dicuser.value) AS l_name, construct_category_dicuser.value AS construct_category_name, construct_category_dicuser.value IS NULL AS construct_category_name_isnull 
FROM construct 
LEFT JOIN dicuser ON (dicuser.output_id = construct.name_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE).") 
LEFT JOIN construct_category ON construct.category_id = construct_category.id
LEFT JOIN dicuser AS construct_category_dicuser ON construct_category_dicuser.output_id = construct_category.name_id AND construct_category_dicuser.language_id = ".sqlf_tl_num($LANGUAGE)." 

WHERE $where $extrawhere ORDER BY construct_category_name_isnull, construct_category.sortorder, construct_category_name, l_name";
$rs = query($sql);//            
 return $rs["arr"];
}

function get_construct_categories() {
global $LANGUAGE;
$sql = "SELECT construct_category.id, name_id, dicuser.value AS name from construct_category LEFT JOIN dicuser ON dicuser.output_id = construct_category.name_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE)." ORDER BY name";
$rs = query( $sql );//            
 $categories = reduce_array( $rs['arr'], 'id', 'name' );
return $categories;
}

function create_tag_menu($node_id, $fstarget = 'top.main.list') {
global $FEATURE;

$tagMenu = Array();
$constructs = (!$FEATURE['construct_categories'] ? get_constructlist($node_id) : get_constructlist_by_category($node_id, " AND construct.intext = 1 "));
$lastCategory = NULL;
$lastCategoryMenu = NULL;
foreach ( $constructs as $constr ) {
$menuEntry = Array( "name"=>$constr["name"], "icon"=>tag_icon($constr["icon"]), "confirm"=>false,
"onclick"=>"cn3_add_tag( cn3_text_range, ".$constr["id"].", '$fstarget');" );
if( $constr['construct_category_name'] !== $lastCategory || $lastCategoryMenu === NULL ) {
$lastCategory = $constr['construct_category_name'];
if( $lastCategory !== NULL ) {
unset( $lastCategoryMenu );
$lastCategoryMenu = Array( );
$tagMenu[] = Array( 'name' => $lastCategory, 'submenu' => & $lastCategoryMenu, 'bold' => true );
}
}
if( $lastCategory === NULL )
$tagMenu[] = $menuEntry;
else
$lastCategoryMenu[] = $menuEntry;
}
return $tagMenu;
}

function create_construct_selectbox($constructs) {
$constructList = array( );

$lastCategory = null;
foreach( $constructs as $construct ) {
$cat = $lastCategory = $construct['construct_category_name'];
if( $cat === null ) {
$cat = i18n( 'No Category' );
}
if($lastCategory != $construct['construct_category_name']) {
//                                                      
 //                                                                                    
 }
//                                                      
 $constructList[$cat][$construct['id']] = $construct['name'];
}
$constructs = $constructList;
return $constructs;
}

?>
