<?php


/**
 * 
 *
 *                                                                                 
 *                 
 **/
class ItemListComponent extends CollectionComponent
{
var $m_list;

function ItemListComponent( $label, &$list )
{
parent::CollectionComponent($label);
$this->d_values["showDetails"] = FALSE;
$this->m_list =& $list;
}

function &getList()
{
return $this->m_list;
}

/**
  *                                   
  *
  *            
  *  
  *         
  **/
function &getDatasource()
{
return $this->m_list->getDatasource();
}

function setWidth( $width )
{
$this->d_values["width"] = $width;
}

function getSerializeKey()
{
$rs = array();
$rs["parent"] = parent::getSerializeKey();
$rs["list"] = node_serialize( $this->m_list );
return $rs;
}

function initFromSerializeKey( $rs )
{
parent::initFromSerializeKey( $rs["parent"] );
$this->m_list =& node_unserialize( $rs["list"] );
}

function onLoadFinished()
{
$this->m_list->load();
}

function getHTML( &$form, $prefix, $doCheck, $checkSeverity, $key )
{
$this->m_list->setParentForm( $form->getFormName() );
$this->m_list->setSubmitFunction( $form->getNonCheckingJSSubmitCall() );
if ( $this->d_values["width"] ) $width = "width=\"".$this->d_values["width"]."\"";
$html = "\n<table border=0 $width><tr><td width=100%>";
$html .= $this->m_list->getHtmlOutput();
$html .= "</td></tr></table>";
return $this->mergeResult( parent::getHTML( $form, $prefix, $doCheck, $checkSeverity, $key ), $html );
}
}

?>
