<?

class FormHISelector extends HISelector {

var $ele;
var $undo_ele;
var $d_action;

function FormHISelector(&$ele, &$comp, $popup) {
parent::HISelector( $comp, !$popup );
$this->d_ele =& $ele;
$this->d_action = "";
$this->updateComponent();
}

function getError($severity) {
return $this->d_ele->getError($severity);
}

function isFinished() {
return $this->d_ele->isFinished();
}

function &getResultObject() {
return $this->d_ele->getResultObject();
}

function setObject(&$obj) {
parent::setObject($obj);
$this->d_ele->setObject($obj);
}

function reset() {
$this->d_ele->reset();
$this->d_component->reset();
}

function updateComponent() {
$comp =& $this->getFormComponent();
if ($this->d_ele->isFinished()) {
$comp->setObject($this->d_ele->getResultObject());
}
}

function resolveAction ( &$form, &$action, $jsParam = "" )
{
switch ( $action->getName() )
{
case "ok":
$this->d_action = "ok";
$this->d_ele = &$form->getComponent( "sel" );
$this->updateComponent();
break;
case "cancel":
$this->d_action = "cancel";
$this->d_ele = $this->undo_ele;
$this->undo_ele = NULL;
break;
default:
parent::resolveAction( $form, $action, $jsParam );
}
}

function handleSelection() {
node_include("htmlform3");

$form = new HtmlForm3R("dialoghisel", $this );
$form->addHeader($this->getHiddenValuesInputFields());

if ($form->isNew()) {
$form->addComponent("sel", $this->d_ele);
$form->addButton("ok", new Button( i18n("ok") ), new SimpleResolvableFormAction("ok") , true );
$form->addButton("cancel", new Button( i18n("cancel") ), new SimpleResolvableFormAction("cancel") );
$this->undo_ele = $this->ele;
}

$btn1 =& $form->getButton("ok");
$btn1->setEnabled( $form->isFinished() );

if( $this->d_action) return true;

$ret = $form->getHTMLOutput();
return $ret;
}

function getSerializeKey() {
$rs = parent::getSerializeKey();
$rs["DialogHISelector:ele"] = node_serialize($this->d_ele);
$rs["DialogHISelector:uele"] = node_serialize($this->undo_ele);
return $rs;
}

function initFromSerializeKey( $key ) {
parent::initFromSerializeKey( $key );
$this->d_ele = &node_unserialize($key["DialogHISelector:ele"]);
$this->undo_ele = &node_unserialize($key["DialogHISelector:uele"]);
}

function getProperty( $key ) {
$rs = $this->getResultObject();
if (is_object($rs) && !is_a($rs,"emessage")) {
$class = $rs->getProperty($key);
} else {
$class = new NodeException("DialogHISelector::getProperty: Could get Result Object for key ($key).");
}
return $class;
}

}

class DialogHiSelector extends FormHiSelector {

function DialogHiSelector(&$ele, &$comp) {
parent::FormHiSelector( $ele, $comp, true );
}
}

class DialogTextHiSelector extends DialogHiSelector {

function DialogTextHiSelector(&$ele, $label = NULL) {
parent::DialogHiSelector( $ele, new TextComponent($label) );
}
}

class FrameHiSelector extends FormHiSelector {

function FrameHiSelector(&$ele, &$comp) {
parent::FormHiSelector( $ele, $comp, false );
}
}

?>
