<?php

class UserHiSelector extends HiSelector {

var $d_userid = -1;

function UserHiSelector() {
parent::HiSelector( new TextComponent() );
}

function isValid() {
if (  $this->d_userid > 0 )
return true;
return "No User selected!";
}

function getUserId()
{
return $this->d_userid;
}

function handleSelection() { 
global $DB, $DO, $uid;

node_include( "item_list" );
node_include( "item_list_sqlds" );
node_include( "userhiselectoraction" );

//                                             
 $urlAdd = $this->getHiddenValuesURLStr();

//                
 $action = new UserHiSelectorAction( );

//                        
 $select = "id, firstname, lastname, login, cdate";
$from   = "systemuser";
$where = "active = 1";

$ds = new SQLDatasource( "people", $select, $from, $where );//            
 $ds->setDBHandle( $DB );
$ds->addColumn( "login", "Login", true, "login", "login" );
$ds->addColumn( "firstname", "Vorname", true, true, true );
$ds->addColumn( "lastname", "Nachname", true, true, true );
$ds->setDefaultAction( $action );
$list = new ItemList3("people",$ds);
$list->setLinkAppendix( $urlAdd );

if ( $action->isPerformed() )
{
$uid = $action->getUserId();
$this->initFromUserId( $uid );
}

if ( isset( $uid ) )
{
return TRUE;
}

return $list->getHTMLOutput();
}

function getSerializeKey()
{
$ret = parent::getSerializeKey();
$ret["UserHiSelectoruserid"] = $this->d_userid;
return $ret;
}

function initFromUserId( $uid )
{
if ( $uid <= 0 || !is_numeric( $uid ) )
return;
$sql = "SELECT login, firstname, lastname FROM systemuser WHERE id=".sqlf_tl_num($uid);
$rs = query( $sql );//            
 $c =& $this->getFormComponent();
$c->setText( $rs["arr"][0]["login"] );
$this->d_userid = $uid;
}

function initFromSerializeKey( $key )
{ 
parent::initFromSerializeKey($key);
$uid = $key["UserHiSelectoruserid"];
$this->initFromUserId( $uid );
}
}



?>