<pre>
<?

function my_xml_start_element($parser, $name, $attrs) {
global $depth;
for ($i = 0; $i < $depth[$parser]; $i++) {
echo "\t";
}
echo $name."\n";
$depth[$parser]++;
}

function my_xml_end_element($parser, $name) {
global $depth;
$depth[$parser]--;
}

function my_xml_data($parser, $data) {
echo $data."\n";
}

$file = "/tmp/xmltest.xml";

$xml_parser = xml_parser_create();
xml_set_element_handler($xml_parser, "my_xml_start_element", "my_xml_end_element");
xml_set_character_data_handler($xml_parser,"my_xml_data");

if (!($fp = fopen($file, "r"))) {
halt(7,"failed opening $file");
}
while ($data = fread($fp, 4096)) {
if (!xml_parse($xml_parser, $data, feof($fp))) {
halt(7,"xml error: ".xml_error_string(xml_get_error_code($xml_parser))." at line ".xml_get_current_line_number($xml_parser));
}
}
xml_parser_free($xml_parser);

?>
</pre>
