<?

class CNFileObject extends CNInFolderObject {

var $file_id = 0;

function CNFileObject($file_id=0) {
parent::CNObject();
$this->setID($file_id);
$this->setViewLinkParams("&do=15000&cmd=update&type=file&id=" . $file_id);
}

function searchInObject($objecttype, $objectid, $searchterm=null, $recursive=false, $fulltext=false) {
if (! in_array($objecttype, $this->getParentTType())) {
return null;
}
$searchsql = "";
if ($searchterm) {
$searchsql = " AND " . $this->_getSearchFilter($searchterm);
}
//                                           
 $folders = array();
if ($searchterm && $recursive) {
mini_walk(&$folders, $objectid);
}
$folders[] = $objectid;
$files = get_files($objectid, $folders, $searchsql);
return $this->_processResultset(array("arr"=>$files));
}

function _getBaseFilter() {
return "LOWER(" . sqlf_table($this->_getNodeTable()) . ".filetype) NOT LIKE 'image%'";
}

function getTType() {
global $T_FILE;
return $T_FILE;
}

function _setID($id) {
$this->file_id = $id; 
}

function getID() {
return $this->file_id;
}

function getIcon() 
{
global $ICO_FILE;
return $ICO_FILE;
}

function _getNodeTable() { return "contentfile"; }

function getValueFields() {
return array('name'=>'text','folder_id'=>false);
}

function& getProperty( $key )
{
switch ( $key )
{
case "id":
return new IntObject($this->getID());
case "name":
return new StringObject($this->getFieldValue("name"));
case "folder":
node_class("cnfolderobject");
$class =&  new CNFolderObject($this->getFieldValue("folder_id"));
return $class;
default:
return parent::getProperty($key);
}		
}

function _checkPermission($parentObjectType, $parentObjectId) {
global $USER_ID;
return perm($USER_ID, $parentObjectType, $parentObjectId, 11, NULL, CT_FILE, 10);
}

function _getSearchFilter($searchterm) {
return "(LOWER(" . sqlf_table($this->_getNodeTable()) . ".name) LIKE '%" . sqlslashes($searchterm) . "%'" .
" OR LOWER(" . sqlf_table($this->_getNodeTable()) . ".description) LIKE '%" . sqlslashes($searchterm) . "%')";
}

function delete() {
return cmd_file_del($this->getID());
}
}

class CNImageObject extends CNInFolderObject {

var $image_id = 0;

function CNImageObject($image_id=0) {
parent::CNObject();
$this->setID($image_id);
$this->setViewLinkParams("do=15000&cmd=update&type=file&id=" . $this->getId());
}

function searchInObject($objecttype, $objectid, $searchterm=null, $recursive=false, $fulltext=false) {
if (! in_array($objecttype, $this->getParentTType())) {
return null;
}
$searchsql = "";
if ($searchterm) {
$searchsql = " AND " . $this->_getSearchFilter($searchterm);
}
//                                           
 $folders = array();
if ($searchterm && $recursive) {
mini_walk(&$folders, $objectid);
}
$folders[] = $objectid;
$files = get_images($objectid, $folders, $searchsql);//            
 return $this->_processResultset(array("arr"=>$files));
}

function _getBaseFilter() {
return "LOWER(" . sqlf_table($this->_getNodeTable()) . ".filetype) LIKE 'image%'";
}

function getTType() {
global $T_IMAGE;
return $T_IMAGE;
}

function _setID($id) {
$this->image_id = $id; 
}

function getID() {
return $this->image_id;
}

function getIcon() 
{
global $ICO_IMG;
return $ICO_IMG;
}

function _getNodeTable() { return "contentfile"; }

function getValueFields() {
return array('name'=>'text', 'folder_id'=>false);
}

function& getProperty( $key )
{
switch ( $key )
{
case "id":
return new IntObject($this->getID());
case "name":
return new StringObject($this->getFieldValue("name"));
case "folder":
node_class("cnfolderobject");
$class =& new CNFolderObject($this->getFieldValue("folder_id"));
return $class;;
default:
return parent::getProperty($key);
}		
}

function _checkPermission($parentObjectType, $parentObjectId) {
global $USER_ID;
return perm($USER_ID, $parentObjectType, $parentObjectId, 11, NULL, CT_FILE, 10);
}

function _getSearchFilter($searchterm) {
return "(LOWER(" . sqlf_table($this->_getNodeTable()) . ".name) LIKE '%" . sqlslashes($searchterm) . "%'" .
" OR LOWER(" . sqlf_table($this->_getNodeTable()) . ".description) LIKE '%" . sqlslashes($searchterm) . "%')";
}

function delete() {
return cmd_file_del($this->getID());
}

function clearCache() {
global $FEATURE, $FILEPATH, $MODULE;
if ($FEATURE["thumbnails"]) {
node_class("img_resize");
$imageResizer = new img_resize();
if ($FEATURE["contentfile_data_to_db"]) {
$imageResizer->load_dbdata($this->getID());
} else {
$imageResizer->load_file("$FILEPATH/$MODULE/dbfiles/" . $this->getID() . ".bin");
}
$imageResizer->clearCache();
}
}
}

?>
